package com.example.aped.communication;

import android.content.Context;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import kotlin.NotImplementedError;

public class Communicator implements IIO{
    private String address;
    private int port;
    private RequestQueue requestQueue;

    public Communicator(String address, int port, Context context){
        this.address = address;
        this.port = port;
        requestQueue = Volley.newRequestQueue(context);
    }

    @Override
    public String read(String deviceName) {
        String requestString = "http://" + address + ":" + port + "/device/" + deviceName;
        JsonObjectRequest request = new JsonObjectRequest(
                Request.Method.GET,
                requestString,
                null,
                new Response.Listener<JSONObject>() {
                    @Override
                    public void onResponse(JSONObject response) {
                        System.out.println(response.toString());
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        System.out.println(error.getMessage());
                    }
                }
        );
        requestQueue.add(request);
        return "";
    }

    @Override
    public String write(String deviceName, String value) {
        throw new NotImplementedError();
    }

    @Override
    public int uploadXML(File xmlFile) {
        throw new NotImplementedError();
    }

    @Override
    public int downloadXML() {
        throw new NotImplementedError();
    }
}
